--- old/usr/src/cmd/mdb/common/mdb/mdb_cmds.c	2013-10-19 13:05:44.942089441 -0400
+++ new/usr/src/cmd/mdb/common/mdb/mdb_cmds.c	2013-10-19 13:05:44.947962164 -0400
@@ -1563,11 +1563,6 @@
 	if (version == NULL)
 		version = "Unknown";
 
-	/*
-	 * The hash table implementation in OVERLOAD mode limits the version
-	 * name to 31 characters because we cannot specify an external name.
-	 * The full version name is available via the ::objects dcmd if needed.
-	 */
 	(void) mdb_nv_insert(vers_nv, version, NULL, (uintptr_t)objname,
 	    MDB_NV_OVERLOAD);
 
--- old/usr/src/cmd/mdb/common/mdb/mdb_nv.c	2013-10-19 13:05:45.198815703 -0400
+++ new/usr/src/cmd/mdb/common/mdb/mdb_nv.c	2013-10-19 13:05:45.204449756 -0400
@@ -38,7 +38,7 @@
 
 #define	NV_SIZE(v) \
 	(((v)->v_flags & MDB_NV_EXTNAME) ? sizeof (mdb_var_t) : \
-	sizeof (mdb_var_t) + MDB_NV_NAMELEN - 1)
+	sizeof (mdb_var_t) + strlen((v)->v_lname))
 
 #define	NV_HASHSZ	211
 
@@ -66,20 +66,24 @@
 nv_var_alloc(const char *name, const mdb_nv_disc_t *disc,
 	uintmax_t value, uint_t flags, uint_t um_flags, mdb_var_t *next)
 {
-	size_t nbytes = (flags & MDB_NV_EXTNAME) ? sizeof (mdb_var_t) :
-	    (sizeof (mdb_var_t) + MDB_NV_NAMELEN - 1);
+	size_t nbytes;
+	mdb_var_t *v;
+
+	if (flags & MDB_NV_EXTNAME)
+		nbytes = sizeof (mdb_var_t);
+	else
+		nbytes = sizeof (mdb_var_t) + strlen(name);
 
-	mdb_var_t *v = mdb_alloc(nbytes, um_flags);
+	v = mdb_alloc(nbytes, um_flags);
 
 	if (v == NULL)
 		return (NULL);
 
 	if (flags & MDB_NV_EXTNAME) {
 		v->v_ename = name;
-		v->v_lname[0] = 0;
+		v->v_lname[0] = '\0';
 	} else {
-		(void) strncpy(v->v_lname, name, MDB_NV_NAMELEN - 1);
-		v->v_lname[MDB_NV_NAMELEN - 1] = '\0';
+		strcpy(v->v_lname, name);
 		v->v_ename = NULL;
 	}
 
--- old/usr/src/cmd/mdb/common/mdb/mdb_tab.c	2013-10-19 13:05:45.365625067 -0400
+++ new/usr/src/cmd/mdb/common/mdb/mdb_tab.c	2013-10-19 13:05:45.371292874 -0400
@@ -394,11 +394,9 @@
 void
 mdb_tab_insert(mdb_tab_cookie_t *mcp, const char *name)
 {
-	size_t len, matches, index;
-	uint_t flags;
+	size_t matches, index;
 	mdb_var_t *v;
 	char *n;
-	const char *nvn;
 
 	/*
 	 * If we have a match set, then we want to verify that we actually match
@@ -412,34 +410,15 @@
 	if (v != NULL)
 		return;
 
-	/*
-	 * Names that we get passed in may be longer than MDB_NV_NAMELEN which
-	 * is currently 31 including the null terminator. If that is the case,
-	 * then we're going to take care of allocating a string and holding it
-	 * for our caller. Note that we don't need to free it, because we're
-	 * allocating this with UM_GC.
-	 */
-	flags = 0;
-	len = strlen(name);
-	if (len > MDB_NV_NAMELEN - 1) {
-		n = mdb_alloc(len + 1, UM_SLEEP | UM_GC);
-		(void) strcpy(n, name);
-		nvn = n;
-		flags |= MDB_NV_EXTNAME;
-	} else {
-		nvn = name;
-	}
-	flags |= MDB_NV_RDONLY;
-
-	(void) mdb_nv_insert(&mcp->mtc_nv, nvn, NULL, 0, flags);
+	(void) mdb_nv_insert(&mcp->mtc_nv, name, NULL, 0, MDB_NV_RDONLY);
 
 	matches = mdb_tab_size(mcp);
 	if (matches == 1) {
-		(void) strlcpy(mcp->mtc_match, nvn, MDB_SYM_NAMLEN);
+		(void) strlcpy(mcp->mtc_match, name, MDB_SYM_NAMLEN);
 	} else {
 		index = 0;
 		while (mcp->mtc_match[index] &&
-		    mcp->mtc_match[index] == nvn[index])
+		    mcp->mtc_match[index] == name[index])
 			index++;
 
 		mcp->mtc_match[index] = '\0';
